// Forlix SoBall
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2008-2011 Dominik Friedrichs

#include <sourcemod>
#include <sdktools>

#pragma semicolon 1

#define PLUGIN_VERSION              "1.23"
#define PLUGIN_VERSION_CVAR         "forlix_soball_version"

#define PLUGIN_COMMAND              "soccer"
#define PLUGIN_COMMAND_DEADTIME     0.75

#define MENU_DISPLAYTIME            0
#define PANEL_DISPLAYTIME           75

#define ANNOUNCEMENT_PREFIX         "\x04Forlix SoBall\x01 -"

#define SOCC_MODELFILE              "models/forlix/soccer/soccerball.mdl"
#define SOCC_MODEL_EXTENT_MIN       Float:{-16.0,-16.0,-16.0}
#define SOCC_MODEL_EXTENT_MAX       Float:{ 16.0, 16.0, 16.0}

#define SPAWN_SUCCEEDED             0
#define SPAWN_DISABLED              1
#define SPAWN_LIMIT_REACHED         2
#define WITHIN_SPAWNPROT_TIME       3
#define SPAWN_POINT_TOO_FAR         4
#define SPAWN_POINT_ON_PLAYER       5
#define SPAWN_FAILED                6

#define SPAWN_SOUND                 "physics/rubber/rubber_tire_impact_hard3.wav"
#define SPAWN_FAILURE_SOUND         "buttons/button11.wav"

#define EXCLUDED_MAP_MSG            "Forlix SoBall unloads (map excluded by config)"

#define LOG_MSG_SPAWN_BALL          "\"%N<%u><%s><%s>\" spawned soccer ball %u/%u"

#define CONFIG_PATH                 "configs/forlix_soball.cfg"
#define TRANSLATION_FILE            "forlix_soball.phrases.txt"

public Plugin:myinfo =
{
  name = "Forlix SoBall",
  author = "Forlix (Dominik Friedrichs)",
  description = "Soccer ball spawning with kill crediting",
  version = PLUGIN_VERSION,
  url = "http://forlix.org/"
};

new log_ball_spawns = 0;
new announcement_type = 0;

new spawncount_per_round = 0;
new spawnprotection_time = 0;
new spawndistance_max = 0;
new allow_spawn_on_players = 0;
new kill_crediting_time = 0;

new Float:round_freeze_end = 0.0;

new String:spawn_cmd[32];

new game_score_ref = INVALID_ENT_REFERENCE;

new bool:p_spawned[MAXPLAYERS+1];
new p_ballspawns[MAXPLAYERS+1];

#include "fs_convars.sp"
#include "fs_events.sp"
#include "fs_entities.sp"
#include "fs_menu.sp"
#include "fs_toolfuncs.sp"
